CON
  _xinfreq = 5_000_000
  _clkmode = xtal1 + pll16x

  SERVO_COUNT = 4
  
VAR
  long Pause, Pulsout 
  byte pin[SERVO_COUNT]                      ' Array of servo I/O pins
  long servo[SERVO_COUNT]                    ' Array of servo pulse duraitons
  long pulseCountAddr, pulseCount            ' The servo pulse count
  long temp, buttons, lv, lh, rv, rh

OBJ
  xbee   : "XBee_Object"
  pst    : "Parallax Serial Terminal"
  Servos : "Servos_PEKIT"
  PS2    : "PS2_Controller"
  

PUB button_control  | t, dt, index

  repeat index from 0 to (SERVO_COUNT - 1)            ' Initialize servo signals
    pin[index]   := lookupz(index: 16,17,18,19) 
    servo[index] := lookupz(index:  0, 0, 0 , 0)
                                                      ' Start servo object
  xbee.start(8, 9, 0, 9600)
  pst.start(9600)
  pst.Home
  buttons := 0
  t  := cnt
  dT := clkfreq/2

  pulseCountAddr := servos.start(@pin[0], @servo[0], SERVO_COUNT)

  repeat

    longfill(@temp, 0, 6)                             ' clear temp..RH 
    repeat until xbee.rx == "!"                       ' Wait for start of message indicator
    repeat index from 0 to 3                          ' Get buttons
      temp := xbee.rx
      temp <<= (index * 8)
      buttons += temp
    rh := xbee.rx & $FF                               ' Get joysticks
    rv := xbee.rx & $FF
    lh := xbee.rx & $FF
    lv := xbee.rx & $FF  

    {{pst.home                                          ' Display
    pst.bin (buttons,32)
    pst.ClearEnd
    pst.newline
    pst.bin(lv, 8)
    pst.bin(lh, 8)
    pst.bin(rv, 8)
    pst.bin(rh, 8)
    pst.ClearEnd
    pst.NewLine

    pst.Str(String("lv = "))
    pst.Dec(lv)
    pst.ClearEnd
    pst.NewLine
    pst.Str(String("lh = "))
    pst.Dec(lh)
    pst.ClearEnd
    pst.NewLine
    pst.Str(String("rv = "))
    pst.Dec(rv)
    pst.ClearEnd
    pst.NewLine
    pst.Str(String("rh = "))
    pst.Dec(rh)
    pst.ClearEnd
    pst.NewLine

        pst.ClearBelow}}


      servo[0] := (128 - lv) * 3                    ' left vertical controls P16 servo
      servo[1] := (128 - lh) * 2                    ' left horizontal controls P17 servo
      servo[2] := (128 - rv) * 3                    ' right vertical controls P18 servo
      servo[3] := (128 - rh) * 2                    ' right horizontal controls P19 servo
    
 
      if !buttons & |< 31                            'Square
          pst.Str(String("      SQUARE_ON: "))
          dira [17] := 1
          outa [17] := 1
      elseifnot buttons  == 1 
          outa [17] := 0
      
      if !buttons & |< 30                          '  X
          pst.Str(String("          X_ON: "))
          dira [16] := 1
          outa [16] := 1
      elseifnot buttons == 1
          outa [16] := 0
    
      if !buttons & |< 29                            'CIRCLE
        pst.Str (String ("      CIRCLE_ON: "))
          dira [18] := 1
          outa [18] := 1
      elseifnot buttons == 1
          outa [18] := 0
          
      if !buttons & |< 28                             'TRIANGLE
          pst.Str(String("    TRIANGLE_ON: "))
          dira [19] := 1
          outa [19] := 1
      elseifnot buttons == 1 
          outa [19] := 0
      
      if !buttons & |< 20                           ' UP
          pst.Str(String("          UP_ON: "))
          dira [20] := 1
          outa [20] := 1
      elseifnot buttons == 1
          outa [20] := 0
    
      if !buttons & |< 22                             'DOWN
        pst.Str (String ("        DOWN_ON: "))
          dira [21] := 1
          outa [21] := 1
      elseifnot buttons == 1
          outa [21] := 0
          
      if !buttons & |< 23                        'LEFT
          pst.Str(String("        LEFT_ON: "))
          dira [22] := 1
          outa [22] := 1
      elseifnot buttons == 1
          outa [22] := 0
      
      if !buttons & |< 21                             'RIGHT
          pst.Str(String("        RIGHT_ON: "))
          dira [23] := 1
          outa [23] := 1
      elseifnot buttons == 1
          outa [23] := 0
    
      if !buttons & |< 26                            'L1
        pst.Str (String ("          L1_ON: "))
          dira [24] := 1
          outa [24] := 1
      elseifnot buttons == 1
          outa [24] := 0
          
      if !buttons & |< 24                         'L2
          pst.Str(String("          L2_ON: "))
          dira [25] := 1
          outa [25] := 1
      elseifnot buttons == 1
          outa [25] := 0
      
      if !buttons & |< 27                         'R1
          pst.Str(String("          R1_ON: "))
          dira [26] := 1
          outa [26] := 1
      elseifnot buttons == 1
          outa [26] := 0
    
      if !buttons & |< 25                             'R2
        pst.Str (String ("          R2_ON: "))
          dira [27] := 1
          outa [27] := 1
      elseifnot buttons == 1
          outa [27] := 0        
      